Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::BandedWG Class Reference

Banded waveguide modeling class. More...

`#include <BandedWG.h>`

Inheritance diagram for stk::BandedWG:

List of all members.

## Public Member Functions
| BandedWG (void)
| Class constructor.
| ~BandedWG (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setStrikePosition (StkFloat position)
| Set strike position (0.0 - 1.0).
void | setPreset (int preset)
| Select a preset.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | startBowing (StkFloat amplitude, StkFloat rate)
| Apply bow velocity/pressure to instrument with given amplitude and rate of increase.
void | stopBowing (StkFloat rate)
| Decrease bow velocity/breath pressure with given rate of decrease.
void | pluck (StkFloat amp)
| Pluck the instrument with given amplitude.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

Banded waveguide modeling class.

This class uses banded waveguide techniques to model a variety of sounds, including bowed bars, glasses, and bowls. For more information, see Essl, G. and Cook, P. "Banded Waveguides: Towards Physical Modelling of Bar Percussion Instruments", Proceedings of the 1999 International Computer Music Conference.

Control Change Numbers:

- Bow Pressure = 2
- Bow Motion = 4
- Strike Position = 8 (not implemented)
- Vibrato Frequency = 11
- Gain = 1
- Bow Velocity = 128
- Set Striking = 64
- Instrument Presets = 16
  - Uniform Bar = 0
  - Tuned Bar = 1
  - Glass Harmonica = 2
  - Tibetan Bowl = 3

by Georg Essl, 1999 - 2004. Modified for STK 4.0 by Gary Scavone.

## Member Function Documentation

StkFrames & stk::BandedWG::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00125 {
    00126   unsigned int nChannels = lastFrame_.channels();
    00127 #if defined(_STK_DEBUG_)
    00128   if ( channel > frames.channels() - nChannels ) {
    00129     oStream_ << "BandedWG::tick(): channel and StkFrames arguments are incompatible!";
    00130     handleError( StkError::FUNCTION_ARGUMENT );
    00131   }
    00132 #endif
    00133
    00134   StkFloat *samples = &frames[channel];
    00135   unsigned int j, hop = frames.channels() - nChannels;
    00136   if ( nChannels == 1 ) {
    00137     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00138       *samples++ = tick();
    00139   }
    00140   else {
    00141     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00142       *samples++ = tick();
    00143       for ( j=1; j<nChannels; j++ )
    00144         *samples++ = lastFrame_[j];
    00145     }
    00146   }
    00147
    00148   return frames;
    00149 }

The documentation for this class was generated from the following file:

- BandedWG.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.